package com.bergerkiller.bukkit.nolagg;

import java.util.List;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.World;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Entity;
import org.bukkit.entity.ExperienceOrb;
import org.bukkit.entity.Item;
import org.bukkit.entity.Player;
import org.bukkit.entity.TNTPrimed;

import com.bergerkiller.bukkit.common.permissions.NoPermissionException;
import com.bergerkiller.bukkit.common.utils.EntityUtil;
import com.bergerkiller.bukkit.nolagg.base.CommandHandler;
import com.bergerkiller.bukkit.nolagg.tnt.TnTHandler;

public class Commands extends CommandHandler {

	private String[] lastargs = new String[1];

	@Override
	public boolean handle(CommandSender sender, String[] args) throws NoPermissionException {		
		if (args.length > 0) {
			boolean all = args[0].equalsIgnoreCase("clearall");
			if (args[0].equalsIgnoreCase("clear") || all) {
				if (sender instanceof Player) {
					Permission.CLEAR.handle(sender);
				} else {
					all = true;
				}
				//fix and partly read args
				boolean tnt = args.length == 1;
				boolean items = tnt;
				boolean animals = false;
				boolean monsters = false;
				boolean remall = false;
				if (args.length == 2) {
					if (args[1].equalsIgnoreCase("last")) {
						args = lastargs;
						sender.sendMessage(ChatColor.GREEN + "The last-used clear command has been invoked:");
					} else {
						List<String> a = NoLagg.clearShortcuts.get(args[1].toLowerCase());
						if (a != null) {
							args = a.toArray(new String[0]);
							sender.sendMessage(ChatColor.GREEN + "Using clear shortcut: " + args[1]);
						}
					}
				}
				String[] toremove = new String[args.length - 1];
				for (int i = 1; i < args.length; i++) {
					String name = args[i].toLowerCase();
					if (name.contains("tnt")) {
						tnt = true;
					} else if (name.contains("item")) {
						items = true;
					} else if (name.contains("animal")) {
						animals = true;
					} else if (name.contains("monster")) {
						monsters = true;
					} else if (name.contains("mob")) {
						animals = true;
						monsters = true;
					} else if (name.contains("all")) {
						remall = true;
					}
					toremove[i - 1] = name;
				}
				args = toremove;
				World[] worlds;
				if (all) {
					worlds = Bukkit.getServer().getWorlds().toArray(new World[0]);
				} else {
					worlds = new World[] {((Player) sender).getWorld()};
				}
				if (tnt && NoLagg.isTNTEnabled) {
					TnTHandler.clear();
				}
				int remcount = 0;
				for (World world : worlds) {
					for (Entity e : world.getEntities()) {
						boolean remove = false;
						if (e instanceof Player) {
							continue;
						} else if (remall) {
							remove = true;
						} else if (args.length == 0) {
							remove = e instanceof Item || e instanceof TNTPrimed || e instanceof ExperienceOrb;
						} else if (e instanceof TNTPrimed && tnt) {
							remove = true;
						} else if (e instanceof Item && items) {
							remove = true;
						} else {
							String type = EntityUtil.getName(e);
							if (animals && EntityUtil.isAnimal(type)) {
								remove = true;
							} else if (monsters && EntityUtil.isMonster(type)) {
								remove = true;
							} else {
								for (String arg : args) {
									if (type.contains(arg) || arg.contains(type)) {
										remove = true;
										break;
									}
								}	
							}
						}
						if (remove) {
							e.remove();
							remcount++;
						}
					}
				}
				if (all) {
					sender.sendMessage(ChatColor.YELLOW + "All worlds have been cleared: " + remcount + " entities removed!");
				} else {
					sender.sendMessage(ChatColor.YELLOW + "This world has been cleared: " + remcount + " entities removed!");
				}
			} else if (args[0].equalsIgnoreCase("monitor") || args[0].equalsIgnoreCase("stat") || args[0].equalsIgnoreCase("stats")) {
				boolean once = !args[0].equalsIgnoreCase("monitor");
				if (sender instanceof Player) {
					Permission.MONITOR.handle(sender);
					Player p = (Player) sender;
					if (PerformanceMonitor.recipients.remove(p.getName())) {
						for (int i = 0; i < 10; i++) {
							p.sendMessage(" ");
						}
						p.sendMessage(ChatColor.YELLOW + "You are no longer monitoring this server.");
					} else {
						PerformanceMonitor.recipients.add(p.getName());
						if (once) {
							p.sendMessage(ChatColor.GREEN + "You will receive a snapshot shortly...");
							PerformanceMonitor.removalReq.add(p.getName());
						} else {
							p.sendMessage(ChatColor.GREEN + "You are now monitoring this server.");
							p.sendMessage(ChatColor.GREEN + "To stop monitoring, perform this command again.");
							PerformanceMonitor.removalReq.remove(p.getName());
						}
					}
				} else {
					if (PerformanceMonitor.sendConsole) {
						PerformanceMonitor.sendConsole = false;
						sender.sendMessage("You are no longer monitoring this server.");
					} else {
						PerformanceMonitor.sendConsole = true;
						if (once) {
							sender.sendMessage("You will receive a snapshot shortly...");
							PerformanceMonitor.removalCon = true;
						} else {
							sender.sendMessage("You are now monitoring this server.");
							sender.sendMessage("To stop monitoring, perform this command again.");
							PerformanceMonitor.removalCon = false;
						}
					}
				}
			} else if (args[0].equalsIgnoreCase("log")) {
				Permission.LOG.handle(sender);
				if (PerformanceMonitor.sendLog) {
					PerformanceMonitor.sendLog = false;
					sender.sendMessage("Server stats are no longer logged to file.");
				} else {
					PerformanceMonitor.sendLog = true;
					sender.sendMessage("Server stats are now logged to file.");
					sender.sendMessage("To stop logging, perform this command again.");
				}
			} else if (args[0].equalsIgnoreCase("clearlog")) {
				Permission.CLEARLOG.handle(sender);
				if (PerformanceMonitor.clearLog()) {
					sender.sendMessage("Server log cleared");
				} else {
					sender.sendMessage("Failed to clear the server log");
				}
			} else if (args[0].equalsIgnoreCase("reload")) {
				Permission.RELOAD.handle(sender);
				NoLagg.plugin.loadConfig();
				sender.sendMessage("Configuration of NoLagg reloaded");
			} else if (args[0].equalsIgnoreCase("gc")) {
				Permission.GC.handle(sender);
				Runtime.getRuntime().gc();
				sender.sendMessage("Memory garbage collected!");
			} else if (args[0].equalsIgnoreCase("mem") || args[0].equalsIgnoreCase("memory")) {
				if (sender instanceof Player) {
					Permission.SHOWMEMORY.handle(sender);
					sender.sendMessage(ChatColor.GREEN + "[Static memory] " + ChatColor.YELLOW + "[Dynamic memory] " + ChatColor.RED + "[Unused memory]");
				}
				sender.sendMessage(PerformanceMonitor.getMemory(sender instanceof Player));
			} else if (args[0].equalsIgnoreCase("lagmem") || args[0].equalsIgnoreCase("memlag")) {
				if (sender instanceof Player) {
					Permission.SHOWTICKRATE.handle(sender);
					Permission.SHOWMEMORY.handle(sender);
					sender.sendMessage(ChatColor.GREEN + "[Static memory] " + ChatColor.YELLOW + "[Dynamic memory] " + ChatColor.RED + "[Unused memory]");
				}
				sender.sendMessage(PerformanceMonitor.getMemory(sender instanceof Player));
				sender.sendMessage(PerformanceMonitor.getTPS(sender instanceof Player));
			} else if (args[0].equalsIgnoreCase("ver") || args[0].equalsIgnoreCase("version")) {
				sender.sendMessage("NoLagg version " + NoLagg.plugin.getDescription().getVersion());
			} else {
				return false;
			}
		} else {
			Permission.SHOWTICKRATE.handle(sender);
			sender.sendMessage(PerformanceMonitor.getTPS(sender instanceof Player));
		}
		return true;
	}

}
