package com.bergerkiller.bukkit.nolagg;

import java.util.HashSet;

import net.minecraft.server.EntityItem;
import net.minecraft.server.WorldServer;

import org.bukkit.Material;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Item;
import org.bukkit.inventory.ItemStack;

import com.bergerkiller.bukkit.common.utils.EntityUtil;
import com.bergerkiller.bukkit.common.utils.ItemUtil;

public class ItemHandler {
	public static boolean formStacks;
	public static boolean ignoreSpawn = false;
	private static HashSet<Material> ignoredTypes = new HashSet<Material>();
				
	public static boolean isIgnoredItem(Entity itementity) {
		if (ItemUtil.isIgnored(itementity)) return true;
		Item item = (Item) itementity;
		return ignoredTypes.contains(item.getItemStack().getType());
	}
	
	public static void clearIgnoredTypes() {
		ignoredTypes.clear();
	}
	public static void addIgnoredType(Material type) {
		ignoredTypes.add(type);
	}
	
	public static void setItem(Item item, ItemStack data) {
		boolean prev = ignoreSpawn;
		ignoreSpawn = true;
		item.remove();
		item.getWorld().dropItem(item.getLocation(), data);
		ignoreSpawn = prev;
	}
	
	public static void respawnItem(Item item) {
		respawnItem(EntityUtil.getNative(item));
	}
	public static void respawnItem(EntityItem item) {
		if (item.dead) return;
		WorldServer world = (WorldServer) item.world;
		world.tracker.untrackEntity(item);
		world.tracker.track(item);
	}
	
}
