package com.bergerkiller.bukkit.nolagg.base;

import java.util.LinkedHashMap;
import java.util.Map;

import org.bukkit.ChatColor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.java.JavaPlugin;

import com.bergerkiller.bukkit.common.PluginBase;
import com.bergerkiller.bukkit.common.permissions.NoPermissionException;

public abstract class NoLaggBase extends PluginBase {

	public NoLaggBase() {
		super();
	}
	public NoLaggBase(int minver, int maxver) {
		super(minver, maxver);
	}
	
	public void updateDependency(Plugin plugin, String pluginname, boolean enabled) {
		if (!enabled) commands.remove(plugin);
	}
	
	private static Map<JavaPlugin, CommandHandler> commands = new LinkedHashMap<JavaPlugin, CommandHandler>();
	
	public final void register(CommandHandler cmd) {
		commands.put(this, cmd);
	}
	
	public final boolean command(CommandSender sender, String cmd, String[] args) {
		try {
			for (CommandHandler handler : commands.values()) {
				if (handler.handle(sender, args)) return true;
			}
			if (sender instanceof Player) {
				sender.sendMessage(ChatColor.RED + "Unknown sub-command!");
			} else {
				sender.sendMessage("Unknown sub-command!");
			}
		} catch (NoPermissionException ex) {
			if (sender instanceof Player) {
				sender.sendMessage(ChatColor.RED + "You don't have permission to use this!");
			} else {
				sender.sendMessage("This command is only for players!");
			}
		}
		return true;
	}
	
}
